Index: uspace/app/sbi/src/lex.c
===================================================================
--- uspace/app/sbi/src/lex.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/lex.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,694 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Lexer (lexical analyzer).
+ *
+ * Consumes a text file and produces a sequence of lexical elements (lems).
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "bigint.h"
+#include "mytypes.h"
+#include "input.h"
+#include "os/os.h"
+#include "strtab.h"
+
+#include "lex.h"
+
+#define TAB_WIDTH 8
+
+static void lex_touch(lex_t *lex);
+static bool_t lex_read_try(lex_t *lex);
+
+static void lex_skip_comment(lex_t *lex);
+static void lex_skip_ws(lex_t *lex);
+static bool_t is_wstart(char c);
+static bool_t is_wcont(char c);
+static bool_t is_digit(char c);
+static void lex_word(lex_t *lex);
+static void lex_char(lex_t *lex);
+static void lex_number(lex_t *lex);
+static void lex_string(lex_t *lex);
+static int digit_value(char c);
+
+/* Note: This imposes an implementation limit on identifier length. */
+#define IBUF_SIZE 128
+static char ident_buf[IBUF_SIZE + 1];
+
+/* XXX This imposes an implementation limit on string literal length. */
+#define SLBUF_SIZE 128
+static char strlit_buf[SLBUF_SIZE + 1];
+
+/** Lclass-string pair */
+struct lc_name {
+	lclass_t lclass;
+	const char *name;
+};
+
+/** Keyword names. Used both for printing and recognition. */
+static struct lc_name keywords[] = {
+	{ lc_as,	"as" },
+	{ lc_bool,	"bool" },
+	{ lc_char,	"char" },
+	{ lc_builtin,	"builtin" },
+	{ lc_class,	"class" },
+	{ lc_constructor,	"constructor" },
+	{ lc_do,	"do" },
+	{ lc_else,	"else" },
+	{ lc_end,	"end" },
+	{ lc_except,	"except" },
+	{ lc_false,	"false" },
+	{ lc_finally,	"finally" },
+	{ lc_for,	"for" },
+	{ lc_fun,	"fun" },
+	{ lc_get,	"get" },
+	{ lc_if,	"if" },
+	{ lc_in,	"in" },
+	{ lc_int,	"int" },
+	{ lc_interface,	"interface" },
+	{ lc_is,	"is" },
+	{ lc_new,	"new" },
+	{ lc_nil,	"nil" },
+	{ lc_override,	"override" },
+	{ lc_packed,	"packed" },
+	{ lc_private,	"private" },
+	{ lc_prop,	"prop" },
+	{ lc_protected,	"protected" },
+	{ lc_public,	"public" },
+	{ lc_raise,	"raise" },
+	{ lc_resource,	"resource" },
+	{ lc_return,	"return" },
+	{ lc_self,	"self" },
+	{ lc_set,	"set" },
+	{ lc_static,	"static" },
+	{ lc_string,	"string" },
+	{ lc_struct,	"struct" },
+	{ lc_then,	"then" },
+	{ lc_this,	"this" },
+	{ lc_true,	"true" },
+	{ lc_var,	"var" },
+	{ lc_with,	"with" },
+	{ lc_while,	"while" },
+	{ lc_yield,	"yield" },
+
+	{ 0,		NULL }
+};
+
+/** Other simple lclasses. Only used for printing. */
+static struct lc_name simple_lc[] = {
+	{ lc_invalid,	"INVALID" },
+	{ lc_eof,	"EOF" },
+
+	/* Operators */
+	{ lc_period,	"." },
+	{ lc_slash,	"/" },
+	{ lc_lparen,	"(" },
+	{ lc_rparen,	")" },
+	{ lc_lsbr,	"[" },
+	{ lc_rsbr,	"]" },
+	{ lc_equal,	"==" },
+	{ lc_notequal,	"!=" },
+	{ lc_lt,	"<" },
+	{ lc_gt,	">" },
+	{ lc_lt_equal,	"<=" },
+	{ lc_gt_equal,	">=" },
+	{ lc_assign,	"=" },
+	{ lc_plus,	"+" },
+	{ lc_minus,	"-" },
+	{ lc_mult,	"*" },
+	{ lc_increase,	"+=" },
+
+	/* Punctuators */
+	{ lc_comma,	"," },
+	{ lc_colon,	":" },
+	{ lc_scolon,	";" },
+
+	{ 0,		NULL },
+};
+
+/** Print lclass value.
+ *
+ * Prints lclass (lexical element class) value in human-readable form
+ * (for debugging).
+ *
+ * @param lclass	Lclass value for display.
+ */
+void lclass_print(lclass_t lclass)
+{
+	struct lc_name *dp;
+
+	dp = keywords;
+	while (dp->name != NULL) {
+		if (dp->lclass == lclass) {
+			printf("%s", dp->name);
+			return;
+		}
+		++dp;
+	}
+
+	dp = simple_lc;
+	while (dp->name != NULL) {
+		if (dp->lclass == lclass) {
+			printf("%s", dp->name);
+			return;
+		}
+		++dp;
+	}
+
+	switch (lclass) {
+	case lc_ident:
+		printf("ident");
+		break;
+	case lc_lit_int:
+		printf("int_literal");
+		break;
+	case lc_lit_string:
+		printf("string_literal");
+		break;
+	default:
+		printf("<unknown?>");
+		break;
+	}
+}
+
+/** Print lexical element.
+ *
+ * Prints lexical element in human-readable form (for debugging).
+ *
+ * @param lem		Lexical element for display.
+ */
+void lem_print(lem_t *lem)
+{
+	lclass_print(lem->lclass);
+
+	switch (lem->lclass) {
+	case lc_ident:
+		printf("(%d)", lem->u.ident.sid);
+		break;
+	case lc_lit_int:
+		printf("(");
+		bigint_print(&lem->u.lit_int.value);
+		printf(")");
+		break;
+	case lc_lit_string:
+		printf("(\"%s\")", lem->u.lit_string.value);
+	default:
+		break;
+	}
+}
+
+/** Print lem coordinates.
+ *
+ * Print the coordinates (line number, column number) of a lexical element.
+ *
+ * @param lem		Lexical element for coordinate printing.
+ */
+void lem_print_coords(lem_t *lem)
+{
+	printf("%d:%d", lem->line_no, lem->col_0);
+}
+
+/** Initialize lexer instance.
+ *
+ * @param lex		Lexer object to initialize.
+ * @param input		Input to associate with lexer.
+ */
+void lex_init(lex_t *lex, struct input *input)
+{
+	int rc;
+
+	lex->input = input;
+
+	rc = input_get_line(lex->input, &lex->inbuf);
+	if (rc != EOK) {
+		printf("Error reading input.\n");
+		exit(1);
+	}
+
+	lex->ibp = lex->inbuf;
+	lex->col_adj = 0;
+	lex->current_valid = b_true;
+}
+
+/** Advance to next lexical element.
+ *
+ * The new element is read in lazily then it is actually accessed.
+ *
+ * @param lex		Lexer object.
+ */
+void lex_next(lex_t *lex)
+{
+	/* Make sure the current lem has already been read in. */
+	lex_touch(lex);
+
+	/* Force a new lem to be read on next access. */
+	lex->current_valid = b_false;
+}
+
+/** Get current lem.
+ *
+ * The returned pointer is invalidated by next call to lex_next()
+ *
+ * @param lex		Lexer object.
+ * @return		Pointer to current lem. Owned by @a lex and only valid
+ *			until next call to lex_next().
+ */
+lem_t *lex_get_current(lex_t *lex)
+{
+	lex_touch(lex);
+	return &lex->current;
+}
+
+/** Read in the current lexical element (unless already read in).
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_touch(lex_t *lex)
+{
+	bool_t got_lem;
+
+	if (lex->current_valid == b_true)
+		return;
+
+	do {
+		got_lem = lex_read_try(lex);
+	} while (got_lem == b_false);
+
+	lex->current_valid = b_true;
+}
+
+/** Try reading next lexical element.
+ *
+ * Attemps to read the next lexical element. In some cases (such as a comment)
+ * this function will need to give it another try and returns @c b_false
+ * in such case.
+ *
+ * @param lex		Lexer object.
+ * @return		@c b_true on success or @c b_false if it needs
+ *			restarting. On success the lem is stored to
+ *			the current lem in @a lex.
+ */
+static bool_t lex_read_try(lex_t *lex)
+{
+	char *bp;
+
+	lex_skip_ws(lex);
+
+	/*
+	 * Record lem coordinates. Line number we already have. For column
+	 * number we start with position in the input buffer. This works
+	 * for all characters except tab. Thus we keep track of tabs
+	 * separately using col_adj.
+	 */
+	lex->current.line_no = input_get_line_no(lex->input);
+	lex->current.col_0 = 1 + lex->col_adj + (lex->ibp - lex->inbuf);
+
+	bp = lex->ibp;
+
+	if (bp[0] == '\0') {
+		/* End of input */
+		lex->current.lclass = lc_eof;
+		return b_true;
+	}
+
+	if (is_wstart(bp[0])) {
+		lex_word(lex);
+		return b_true;
+	}
+
+	if (bp[0] == '\'') {
+		lex_char(lex);
+		return b_true;
+	}
+
+	if (is_digit(bp[0])) {
+		lex_number(lex);
+		return b_true;
+	}
+
+	if (bp[0] == '"') {
+		lex_string(lex);
+		return b_true;
+	}
+
+	if (bp[0] == '-' && bp[1] == '-') {
+		lex_skip_comment(lex);
+		return b_false;
+	}
+
+	switch (bp[0]) {
+	case ',': lex->current.lclass = lc_comma; ++bp; break;
+	case ':': lex->current.lclass = lc_colon; ++bp; break;
+	case ';': lex->current.lclass = lc_scolon; ++bp; break;
+
+	case '.': lex->current.lclass = lc_period; ++bp; break;
+	case '/': lex->current.lclass = lc_slash; ++bp; break;
+	case '(': lex->current.lclass = lc_lparen; ++bp; break;
+	case ')': lex->current.lclass = lc_rparen; ++bp; break;
+	case '[': lex->current.lclass = lc_lsbr; ++bp; break;
+	case ']': lex->current.lclass = lc_rsbr; ++bp; break;
+
+	case '=':
+		if (bp[1] == '=') {
+			lex->current.lclass = lc_equal; bp += 2; break;
+		}
+		lex->current.lclass = lc_assign; ++bp; break;
+
+	case '!':
+		if (bp[1] == '=') {
+			lex->current.lclass = lc_notequal; bp += 2; break;
+		}
+		goto invalid;
+
+	case '+':
+		if (bp[1] == '=') {
+			lex->current.lclass = lc_increase; bp += 2; break;
+		}
+		lex->current.lclass = lc_plus; ++bp; break;
+
+	case '-':
+		lex->current.lclass = lc_minus; ++bp; break;
+
+	case '*':
+		lex->current.lclass = lc_mult; ++bp; break;
+
+	case '<':
+		if (bp[1] == '=') {
+			lex->current.lclass = lc_lt_equal; bp += 2; break;
+		}
+		lex->current.lclass = lc_lt; ++bp; break;
+
+	case '>':
+		if (bp[1] == '=') {
+			lex->current.lclass = lc_gt_equal; bp += 2; break;
+		}
+		lex->current.lclass = lc_gt; ++bp; break;
+
+	default:
+		goto invalid;
+	}
+
+	lex->ibp = bp;
+	return b_true;
+
+invalid:
+	lex->current.lclass = lc_invalid;
+	++bp;
+	lex->ibp = bp;
+
+	return b_true;
+}
+
+/** Lex a word (identifier or keyword).
+ *
+ * Read in a word. This may later turn out to be a keyword or a regular
+ * identifier. It is stored in the current lem in @a lex.
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_word(lex_t *lex)
+{
+	struct lc_name *dp;
+	char *bp;
+	int idx;
+
+	bp = lex->ibp;
+	ident_buf[0] = bp[0];
+	idx = 1;
+
+	while (is_wcont(bp[idx])) {
+		if (idx >= IBUF_SIZE) {
+			printf("Error: Identifier too long.\n");
+			exit(1);
+		}
+
+		ident_buf[idx] = bp[idx];
+		++idx;
+	}
+
+	lex->ibp = bp + idx;
+
+	ident_buf[idx] = '\0';
+
+	dp = keywords;
+	while (dp->name != NULL) {
+		if (os_str_cmp(ident_buf, dp->name) == 0) {
+			/* Match */
+			lex->current.lclass = dp->lclass;
+			return;
+		}
+		++dp;
+	}
+
+	/* No matching keyword -- it must be an identifier. */
+	lex->current.lclass = lc_ident;
+	lex->current.u.ident.sid = strtab_get_sid(ident_buf);
+}
+
+/** Lex a character literal.
+ *
+ * Reads in a character literal and stores it in the current lem in @a lex.
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_char(lex_t *lex)
+{
+	char *bp;
+	int idx;
+	size_t len;
+	int char_val;
+
+	bp = lex->ibp + 1;
+	idx = 0;
+
+	while (bp[idx] != '\'') {
+		if (idx >= SLBUF_SIZE) {
+			printf("Error: Character literal too long.\n");
+			exit(1);
+		}
+
+		if (bp[idx] == '\0') {
+			printf("Error: Unterminated character literal.\n");
+			exit(1);
+		}
+
+		strlit_buf[idx] = bp[idx];
+		++idx;
+	}
+
+	lex->ibp = bp + idx + 1;
+
+	strlit_buf[idx] = '\0';
+	len = os_str_length(strlit_buf);
+	if (len != 1) {
+		printf("Character literal should contain one character, "
+		    "but contains %u characters instead.\n", (unsigned) len);
+		exit(1);
+	}
+
+	os_str_get_char(strlit_buf, 0, &char_val);
+	lex->current.lclass = lc_lit_char;
+	bigint_init(&lex->current.u.lit_char.value, char_val);
+}
+
+/** Lex a numeric literal.
+ *
+ * Reads in a numeric literal and stores it in the current lem in @a lex.
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_number(lex_t *lex)
+{
+	char *bp;
+	bigint_t value;
+	bigint_t dgval;
+	bigint_t base;
+	bigint_t tprod;
+
+	bp = lex->ibp;
+
+	bigint_init(&value, 0);
+	bigint_init(&base, 10);
+
+	while (is_digit(*bp)) {
+		bigint_mul(&value, &base, &tprod);
+		bigint_init(&dgval, digit_value(*bp));
+
+		bigint_destroy(&value);
+		bigint_add(&tprod, &dgval, &value);
+		bigint_destroy(&tprod);
+		bigint_destroy(&dgval);
+
+		++bp;
+	}
+
+	bigint_destroy(&base);
+
+	lex->ibp = bp;
+
+	lex->current.lclass = lc_lit_int;
+	bigint_shallow_copy(&value, &lex->current.u.lit_int.value);
+}
+
+/** Lex a string literal.
+ *
+ * Reads in a string literal and stores it in the current lem in @a lex.
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_string(lex_t *lex)
+{
+	char *bp;
+	int idx;
+
+	bp = lex->ibp + 1;
+	idx = 0;
+
+	while (bp[idx] != '"') {
+		if (idx >= SLBUF_SIZE) {
+			printf("Error: String literal too long.\n");
+			exit(1);
+		}
+
+		if (bp[idx] == '\0') {
+			printf("Error: Unterminated string literal.\n");
+			exit(1);
+		}
+
+		strlit_buf[idx] = bp[idx];
+		++idx;
+	}
+
+	lex->ibp = bp + idx + 1;
+
+	strlit_buf[idx] = '\0';
+
+	lex->current.lclass = lc_lit_string;
+	lex->current.u.lit_string.value = os_str_dup(strlit_buf);
+}
+
+/** Lex a single-line comment.
+ *
+ * This does not produce any lem. The comment is just skipped.
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_skip_comment(lex_t *lex)
+{
+	char *bp;
+
+	bp = lex->ibp + 2;
+
+	while (*bp != '\n' && *bp != '\0') {
+		++bp;
+	}
+
+	lex->ibp = bp;
+}
+
+/** Skip whitespace characters.
+ *
+ * This does not produce any lem. The whitespace is just skipped.
+ *
+ * @param lex		Lexer object.
+ */
+static void lex_skip_ws(lex_t *lex)
+{
+	char *bp;
+	int rc;
+
+	bp = lex->ibp;
+
+	while (b_true) {
+		while (*bp == ' ' || *bp == '\t') {
+			if (*bp == '\t') {
+				/* XXX This is too simplifed. */
+				lex->col_adj += (TAB_WIDTH - 1);
+			}
+			++bp;
+		}
+
+		if (*bp != '\n')
+			break;
+
+		/* Read next line */
+		rc = input_get_line(lex->input, &lex->inbuf);
+		if (rc != EOK) {
+			printf("Error reading input.\n");
+			exit(1);
+		}
+
+		bp = lex->inbuf;
+		lex->col_adj = 0;
+	}
+
+	lex->ibp = bp;
+}
+
+/** Determine if character can start a word.
+ *
+ * @param c 	Character.
+ * @return	@c b_true if @a c can start a word, @c b_false otherwise.
+ */
+static bool_t is_wstart(char c)
+{
+	return ((c >= 'a') && (c <= 'z')) || ((c >= 'A') && (c <= 'Z')) ||
+	    (c == '_');
+}
+
+/** Determine if character can continue a word.
+ *
+ * @param c 	Character.
+ * @return	@c b_true if @a c can start continue word, @c b_false
+ *		otherwise.
+ */
+static bool_t is_wcont(char c)
+{
+	return is_digit(c) || is_wstart(c);
+}
+
+/** Determine if character is a numeric digit.
+ *
+ * @param c 	Character.
+ * @return	@c b_true if @a c is a numeric digit, @c b_false otherwise.
+ */
+static bool_t is_digit(char c)
+{
+	return ((c >= '0') && (c <= '9'));
+}
+
+/** Determine numeric value of digit character.
+ *
+ * @param c 	Character, must be a valid decimal digit.
+ * @return	Value of the digit (0-9).
+ */
+static int digit_value(char c)
+{
+	return (c - '0');
+}
Index: uspace/app/sbi/src/lex.h
===================================================================
--- uspace/app/sbi/src/lex.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/lex.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef LEX_H_
+#define LEX_H_
+
+#include "mytypes.h"
+
+void lclass_print(lclass_t lclass);
+void lem_print(lem_t *lem);
+void lem_print_coords(lem_t *lem);
+
+void lex_init(lex_t *lex, struct input *input);
+void lex_next(lex_t *lex);
+lem_t *lex_get_current(lex_t *lex);
+
+#endif
Index: uspace/app/sbi/src/lex_t.h
===================================================================
--- uspace/app/sbi/src/lex_t.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/lex_t.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,176 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef LEX_T_H_
+#define LEX_T_H_
+
+#include "bigint_t.h"
+
+/** Lexical element class */
+typedef enum {
+	lc_invalid,
+	lc_eof,
+
+	lc_ident,
+	lc_lit_char,
+	lc_lit_int,
+	lc_lit_string,
+
+	/* Keywords */
+	lc_as,
+	lc_bool,
+	lc_builtin,
+	lc_char,
+	lc_class,
+	lc_constructor,
+	lc_do,
+	lc_else,
+	lc_end,
+	lc_except,
+	lc_false,
+	lc_finally,
+	lc_for,
+	lc_fun,
+	lc_new,
+	lc_get,
+	lc_if,
+	lc_in,
+	lc_int,
+	lc_interface,
+	lc_is,
+	lc_nil,
+	lc_override,
+	lc_packed,
+	lc_private,
+	lc_prop,
+	lc_protected,
+	lc_public,
+	lc_raise,
+	lc_resource,
+	lc_return,
+	lc_self,
+	lc_set,
+	lc_static,
+	lc_string,
+	lc_struct,
+	lc_then,
+	lc_this,
+	lc_true,
+	lc_var,
+	lc_with,
+	lc_while,
+	lc_yield,
+
+	/* Operators */
+	lc_period,
+	lc_slash,
+	lc_lparen,
+	lc_rparen,
+	lc_lsbr,
+	lc_rsbr,
+	lc_equal,
+	lc_notequal,
+	lc_lt,
+	lc_gt,
+	lc_lt_equal,
+	lc_gt_equal,
+	lc_assign,
+	lc_plus,
+	lc_minus,
+	lc_mult,
+	lc_increase,
+
+	/* Punctuators */
+	lc_comma,
+	lc_colon,
+	lc_scolon,
+
+	lc__limit
+} lclass_t;
+
+typedef struct {
+	/* String ID */
+	int sid;
+} lem_ident_t;
+
+typedef struct {
+	/* Character value */
+	bigint_t value;
+} lem_lit_char_t;
+
+typedef struct {
+	/* Integer value */
+	bigint_t value;
+} lem_lit_int_t;
+
+typedef struct {
+	/* String value */
+	char *value;
+} lem_lit_string_t;
+
+/** Lexical element */
+typedef struct {
+	/* Lexical element class */
+	lclass_t lclass;
+
+	union {
+		lem_ident_t ident;
+		lem_lit_char_t lit_char;
+		lem_lit_int_t lit_int;
+		lem_lit_string_t lit_string;
+	} u;
+
+	/** Coordinates of this lexical element */
+	int line_no, col_0;
+} lem_t;
+
+/** Lexer state object */
+typedef struct lex {
+	/** Input object */
+	struct input *input;
+
+	/** Lexing buffer */
+	char *inbuf;
+
+	/** Pointer to current position in lexing buffer */
+	char *ibp;
+
+	/** Number of the line currently in inbuf */
+	int ib_line;
+
+	/** Column number adjustment (due to tabs) */
+	int col_adj;
+
+	/** @c b_true if we have the next lem in @c current */
+	bool_t current_valid;
+
+	/** Curent lem (only valid if @c current_valid is true) */
+	lem_t current;
+} lex_t;
+
+#endif
Index: uspace/app/sbi/src/list.c
===================================================================
--- uspace/app/sbi/src/list.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/list.c	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,288 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Doubly linked list.
+ *
+ * Circular, with a head. Nodes structures are allocated separately from data.
+ * Data is stored as 'void *'. We implement several sanity checks to prevent
+ * common usage errors.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <assert.h>
+#include "mytypes.h"
+
+#include "list.h"
+
+static list_node_t *list_node_new(void *data);
+static void list_node_delete(list_node_t *node);
+static void list_node_insert_between(list_node_t *n, list_node_t *a, list_node_t *b);
+static void list_node_unlink(list_node_t *n);
+static bool_t list_node_present(list_t *list, list_node_t *node);
+
+/** Initialize list.
+ *
+ * @param list	List to initialize.
+ */
+void list_init(list_t *list)
+{
+	list->head.prev = &list->head;
+	list->head.next = &list->head;
+}
+
+/** Append data to list.
+ *
+ * Create a new list node and append it at the end of the list.
+ *
+ * @param list	Linked list.
+ * @param data	Data for the new node.
+ */
+void list_append(list_t *list, void *data)
+{
+	list_node_t *node;
+
+	node = list_node_new(data);
+	list_node_insert_between(node, list->head.prev, &list->head);
+}
+
+/** Prepend data to list.
+ *
+ * Create a new list node and prepend it at the beginning of the list.
+ *
+ * @param list	Linked list.
+ * @param data	Data for the new node.
+ */
+void list_prepend(list_t *list, void *data)
+{
+	list_node_t *node;
+
+	node = list_node_new(data);
+	list_node_insert_between(node, list->head.prev, &list->head);
+}
+
+/** Remove data from list.
+ *
+ * Removes the given node from a list and destroys it. Any data the node might
+ * have is ignored. If asserts are on, we check wheter node is really present
+ * in the list the caller is requesting us to remove it from.
+ *
+ * @param list	Linked list.
+ * @param node	List node to remove.
+ */
+void list_remove(list_t *list, list_node_t *node)
+{
+	/* Check whether node is in the list as claimed. */
+	assert(list_node_present(list, node));
+	list_node_unlink(node);
+	node->data = NULL;
+	list_node_delete(node);
+}
+
+/** Return first list node or NULL if list is empty.
+ *
+ * @param list	Linked list.
+ * @return	First node of the list or @c NULL if the list is empty.
+ */
+list_node_t *list_first(list_t *list)
+{
+	list_node_t *node;
+
+	assert(list != NULL);
+	node = list->head.next;
+
+	return (node != &list->head) ? node : NULL;
+}
+
+/** Return last list node or NULL if list is empty.
+ *
+ * @param list	Linked list.
+ * @return	Last node of the list or @c NULL if the list is empty.
+ */
+list_node_t *list_last(list_t *list)
+{
+	list_node_t *node;
+
+	assert(list != NULL);
+	node = list->head.prev;
+
+	return (node != &list->head) ? node : NULL;
+}
+
+/** Return next list node or NULL if this was the last one.
+ *
+ * @param list	Linked list.
+ * @param node	Node whose successor we are interested in.
+ * @return	Following list node or @c NULL if @a node is last.
+ */
+list_node_t *list_next(list_t *list, list_node_t *node)
+{
+	(void) list;
+	assert(list != NULL);
+	assert(node != NULL);
+
+	return (node->next != &list->head) ? node->next : NULL;
+}
+
+/** Return previous list node or NULL if this was the last one.
+ *
+ * @param list	Linked list.
+ * @param node	Node whose predecessor we are interested in.
+ * @return	Preceding list node or @c NULL if @a node is last.
+ */
+list_node_t *list_prev(list_t *list, list_node_t *node)
+{
+	(void) list;
+	assert(list != NULL);
+	assert(node != NULL);
+
+	return (node->prev != &list->head) ? node->prev : NULL;
+}
+
+/** Return b_true if list is empty.
+ *
+ * @param list	Linked list.
+ * @return	@c b_true if list is empty, @c b_false otherwise.
+ */
+bool_t list_is_empty(list_t *list)
+{
+	return (list_first(list) == NULL);
+}
+
+/** Change node data.
+ *
+ * Change the data associated with a node.
+ *
+ * @param node	List node.
+ * @param data	New data for node.
+ */
+void list_node_setdata(list_node_t *node, void *data)
+{
+	node->data = data;
+}
+
+/** Create new node.
+ *
+ * @param data	Initial data for node.
+ * @return	New list node.
+ */
+static list_node_t *list_node_new(void *data)
+{
+	list_node_t *node;
+
+	node = malloc(sizeof(list_node_t));
+	if (node == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	node->prev = NULL;
+	node->next = NULL;
+	node->data = data;
+
+	return node;
+}
+
+/** Delete node.
+ *
+ * @param node	List node. Must not take part in any list.
+ */
+static void list_node_delete(list_node_t *node)
+{
+	assert(node->prev == NULL);
+	assert(node->next == NULL);
+	assert(node->data == NULL);
+	free(node);
+}
+
+/** Insert node between two other nodes.
+ *
+ * Inserts @a n between neighboring nodes @a a and @a b.
+ *
+ * @param n	Node to insert.
+ * @param a	Node to precede @a n.
+ * @param b	Node to follow @a n.
+ */
+static void list_node_insert_between(list_node_t *n, list_node_t *a,
+    list_node_t *b)
+{
+	assert(n->prev == NULL);
+	assert(n->next == NULL);
+	n->prev = a;
+	n->next = b;
+
+	assert(a->next == b);
+	assert(b->prev == a);
+	a->next = n;
+	b->prev = n;
+}
+
+/** Unlink node.
+ *
+ * Unlink node from the list it is currently in.
+ * 
+ * @param n	Node to unlink from its current list.
+ */
+static void list_node_unlink(list_node_t *n)
+{
+	list_node_t *a, *b;
+	assert(n->prev != NULL);
+	assert(n->next != NULL);
+
+	a = n->prev;
+	b = n->next;
+
+	assert(a->next == n);
+	assert(b->prev == n);
+
+	a->next = b;
+	b->prev = a;
+
+	n->prev = NULL;
+	n->next = NULL;
+}
+
+/** Check whether @a node is in list @a list.
+ *
+ * @param list	Linked list.
+ * @param node	Node.
+ * @return	@c b_true if @a node is part of @a list, @c b_false otherwise.
+ */
+static bool_t list_node_present(list_t *list, list_node_t *node)
+{
+	list_node_t *m;
+
+	m = list->head.next;
+	while (m != &list->head) {
+		if (m == node)
+			return b_true;
+		m = m->next;
+	}
+
+	return b_false;
+}
Index: uspace/app/sbi/src/list.h
===================================================================
--- uspace/app/sbi/src/list.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
+++ uspace/app/sbi/src/list.h	(revision 88dea9d01a9bc5e8482c1ceafa6e6531ac50cb4f)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef LIST_H_
+#define LIST_H_
+
+#include "mytypes.h"
+#include "compat.h"
+
+void list_init(list_t *list);
+void list_append(list_t *list, void *data);
+void list_prepend(list_t *list, void *data);
+void list_remove(list_t *list, list_node_t *node);
+
+list_node_t *list_first(list_t *list);
+list_node_t *list_last(list_t *list);
+list_node_t *list_next(list_t *list, list_node_t *node);
+list_node_t *list_prev(list_t *list, list_node_t *node);
+bool_t list_is_empty(list_t *list);
+
+void list_node_setdata(list_node_t *node, void *data);
+
+#define list_node_data(node, dtype) ((dtype)(node->data))
+
+#endif
